/*
 File: linker_preamble_codesym.cpp
 Date and Time: Fri Jan 30 18:55:15 2015 
*/
#include "linker_preamble_code.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_linker_preamble_code;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_linker_preamble_code::TH_linker_preamble_code(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_linker_preamble_code;
  NS_linker_preamble_code::Clinker_preamble_code Clinker_preamble_code_;// parallel-parser's parse table
#define ssPARSE_TABLE Clinker_preamble_code_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_linker_preamble_code::PROC_TH_linker_preamble_code(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_linker_preamble_code";
  static bool one_time(false);
  static NS_linker_preamble_code::Clinker_preamble_code* NS_linker_preamble_code_Clinker_preamble_code_(0);// parallel-parser's fsm table
  static Parser* NS_linker_preamble_code_Clinker_preamble_code_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_linker_preamble_code_Clinker_preamble_code_ = new NS_linker_preamble_code::Clinker_preamble_code();// parallel-parser's fsm table
    NS_linker_preamble_code_Clinker_preamble_code_parser = new Parser(*NS_linker_preamble_code_Clinker_preamble_code_,Caller_pp);
  }
 proc_parser = NS_linker_preamble_code_Clinker_preamble_code_parser;
#include "wproc_pp_core.h"
}
void 
Clinker_preamble_code::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rlinker_preamble_code_:{
       Rlinker_preamble_code* sym;
     if(re->rule_ == 0){
       sym = new Rlinker_preamble_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlinker_preamble_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->op();
     return;}
    case rhs1_Rchrs_:{
       Rchrs* sym;
     if(re->rule_ == 0){
       sym = new Rchrs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchrs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rchrs_:{
       Rchrs* sym;
     if(re->rule_ == 0){
       sym = new Rchrs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchrs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs4_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     sym->op();
     return;}
    case rhs5_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr5();
     sym->op();
     return;}
    case rhs6_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     sym->op();
     return;}
    case rhs7_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     sym->op();
     return;}
    default: return;
   }
}
